//
// Skirmish Base Script.
//
// contains the rules for starting and ending a game.
// as well as warning messages.
//
// /////////////////////////////////////////////////////////////////
///Propulsions
const WHE = "wheeled01";  //WHEELS
const HAL = "HalfTrack";  //HALFTRACK
const TRA = "tracked01";  //TRACK
const HOV = "hover01";    //HOVER
const VTO = "V-Tol";      //VTOL
const CLE = "CyborgLegs"; //CyborgLegs

///Bodies.
const DRA = "Body14SUP";  //Dragon
const WYV = "Body13SUP";  //Wyvern
const VEN = "Body10MBT";  //Vengeance
const TIG = "Body9REC";   //Tiger
const RET = "Body7ABT";   //Retribution
const PAN = "Body6SUPP";  //Panther
const MAN = "Body12SUP";  //Mantis
const PYT = "Body11ABT";  //Python
const SCO = "Body8MBT";   //Scorpion
const RET = "Body3MBT";   //Retaliation
const COB = "Body5REC";   //Cobra
const LEO = "Body2SUP";   //Leopard
const BUG = "Body4ABT";   //Bug
const VIP = "Body1REC";   //Viper
const BOR = "CyborgLightBody";
const SBO =	"CyborgHeavyBody";
///Weapons

//CyborgWeapons
const CMG = "CyborgChaingun"; // mg cyborg
const CF1 = "CyborgFlamer01";// flamer cyborg
const CC1 = "CyborgCannon"; // lc borg
const CMO = "Cyb-Wpn-Grenade"; // mortar borg
const CLA = "CyborgRocket"; // lancer borg
const CF2 = "Cyb-Wpn-Thermite"; // thermite cyborg
const CAG = "CyborgRotMG"; // ag cyborg
const CC2 = "Cyb-Hvywpn-Mcannon"; // mc super
const CC3 = "Cyb-Hvywpn-HPV"; // hpv super
const CTK = "Cyb-Hvywpn-TK"; // tk super
const CC4 = "Cyb-Hvywpn-Acannon"; // ac super
const CL1 = "Cyb-Wpn-Laser"; // flash borg
const CM1 = "Cyb-Wpn-Atmiss"; // scourge borg
const CR1 = "Cyb-Wpn-Rail1"; // needle borg
const CL2 = "Cyb-Hvywpn-PulseLsr"; // pulse super
const CM2 = "Cyb-Hvywpn-A-T"; // scourge super
const CR2 = "Cyb-Hvywpn-RailGunner"; // rail super


//TankWeapons
const MG1 = "MG1Mk1";  //MG
const MG2 =	"MG2Mk1";  //TwinMG
const MG3 =	"MG3Mk1";  //HMG
const MG4 =	"MG4ROTARYMk1"; //assaultGun
const MG5 =	"MG5TWINROTARY";//Twinassault
const LS1 =	"Laser3BEAMMk1";// 1 laser
const LS2 =	"Laser2PULSEMk1";// pulse laser
const LS3 =	"HeavyLaser";
		

		
const CA1 =	"Cannon1Mk1"; //light cannon
const CA2 =	"Cannon2A-TMk1"; //med cannon
const CA3 =	"Cannon4AUTOMk1"; //HVcannon
const CA4 =	"Cannon5VulcanMk1"; //assaultCannon
const CA5 =	"Cannon6TwinAslt"; 
const CA6 =	"Cannon375mmMk1"; //HeavyCannon
const RA1 =	"RailGun1Mk1"; // needle
const RA2 =	"RailGun2Mk1";
const RA3 =	"RailGun3Mk1";
		

		
const RO1 =	"Rocket-Pod";  //minipod
const RO2 =	"Rocket-LtA-T";//lanser
const RO3 =	"Rocket-MRL"; //MiniROcketArray
const RO4 =	"Rocket-IDF"; //tankKiller
const RO5 =	"Rocket-HvyA-T";//riple
const MI1 =	"Missile-A-T"; //
const MI2 =	"Missile-MdArt"; //SERAPH
const MI3 =	"Missile-HvyArt"; //ARchAngel
		

		
const FL1 =	"Flame1Mk1";
const FL2 =	"Flame2";
const FL3 =	"PlasmiteFlamer";
		

		
const MO1 =	"Mortar1Mk1";
const MO2 =	"Mortar2Mk1"; //bombard
const MO3 =	"Mortar3ROTARYMk1";
const MO4 =	"Mortar-Incenediary";
const HO1 =	"Howitzer105Mk1";
const HO2 =	"Howitzer03-Rot";
const HO3 =	"Howitzer150Mk1"; //GroundShaker
const HO4 =	"Howitzer-Incenediary";
		
//VTOL-WEAPON
	
const MV1 =	"MG1-VTOL"; //MG
const MV2 =	"MG2-VTOL"; //TMG
const MV3 =	"MG3-VTOL"; //HMG
const MV4 =	"MG4ROTARY-VTOL"; //assaultGun
const LV1 =	"Laser3BEAM-VTOL"; //1 laser
const LV2 =	"Laser2PULSE-VTOL";
const LV3 =	"HeavyLaser-VTOL";
		
		
		
const RV1 =	"Rocket-VTOL-Pod";
const RV2 =	"Rocket-VTOL-LtA-T";
const RV3 =	"Rocket-VTOL-HvyA-T";
const RV4 =	"Rocket-VTOL-BB"; //BunkerBAster
const MV5 =	"Missile-VTOL-AT";
		
		
		
const CV1 =	"Cannon1-VTOL";//light cannon
const CV2 =	"Cannon4AUTO-VTOL"; //HVC
const CV3 =	"Cannon5Vulcan-VTOL"; //assaultCannon
const RV1 =	"RailGun1-VTOL";
const RV2 =	"RailGun2-VTOL";
		
		
		
const BO1 =	"Bomb1-VTOL-LtHE"; //
const BO2 =	"Bomb3-VTOL-LtINC";//incen 1 bomb
const BO3 =	"Bomb2-VTOL-HvHE"; // HEAP bomb
const BO4 =	"Bomb4-VTOL-HvyINC"; //incen 2 bomb
const BO5 =	"Bomb5-VTOL-Plasmite"; //Plasma bomb
		

receiveAllEvents(true);  // If doing this in eventGameInit, it seems to be too late in T2/T3, due to some eventResearched events triggering first.

var lastHitTime = 0;
var cheatmode = false;
var maxOilDrums = 0;

function setupGame()
{
	if (tilesetType == "URBAN")
	{
		replaceTexture("page-8-player-buildings-bases.png", "page-8-player-buildings-bases-urban.png");
		replaceTexture("page-9-player-buildings-bases.png", "page-9-player-buildings-bases-urban.png");
		replaceTexture("page-7-barbarians-arizona.png", "page-7-barbarians-urban.png");
	}
	else if (tilesetType == "ROCKIES")
	{
		replaceTexture("page-8-player-buildings-bases.png", "page-8-player-buildings-bases-rockies.png");
		replaceTexture("page-9-player-buildings-bases.png", "page-9-player-buildings-bases-rockies.png");
		// for some reason rockies will use arizona babas
	}
	if (tilesetType != "ARIZONA")
	{
		setSky("texpages/page-25-sky-urban.png", 0.5, 10000.0);
	}
	setReticuleButton(0, _("Close"), "image_cancel_up.png", "image_cancel_down.png");
	setReticuleButton(1, _("Manufacture (F1)"), "image_manufacture_up.png", "image_manufacture_down.png");
	setReticuleButton(2, _("Research (F2)"), "image_research_up.png", "image_research_down.png");
	setReticuleButton(3, _("Build (F3)"), "image_build_up.png", "image_build_down.png");
	setReticuleButton(4, _("Design (F4)"), "image_design_up.png", "image_design_down.png");
	setReticuleButton(5, _("Intelligence Display (F5)"), "image_intelmap_up.png", "image_intelmap_down.png");
	setReticuleButton(6, _("Commanders (F6)"), "image_commanddroid_up.png", "image_commanddroid_down.png");
	showInterface();
}

function eventGameLoaded()
{
	setupGame();
}

function eventGameInit()
{
	setupGame();

	// always at least one oil drum, and one more for every 64x64 tiles of map area
	maxOilDrums = (mapWidth * mapHeight) >> 12; // replace float division with shift for sync-safety
	for (var i = 0; i < maxOilDrums; ++i)
	{
		queue("placeOilDrum", 10000 * i);
	}


	hackNetOff();
	makeComponentAvailable("B4body-sml-trike01", scavengerPlayer);
	makeComponentAvailable("B3body-sml-buggy01", scavengerPlayer);
	makeComponentAvailable("B2JeepBody", scavengerPlayer);
	makeComponentAvailable("BusBody", scavengerPlayer);
	makeComponentAvailable("FireBody", scavengerPlayer);
	makeComponentAvailable("B1BaBaPerson01", scavengerPlayer);
	makeComponentAvailable("BaBaProp", scavengerPlayer);
	makeComponentAvailable("BaBaLegs", scavengerPlayer);
	makeComponentAvailable("bTrikeMG", scavengerPlayer);
	makeComponentAvailable("BuggyMG", scavengerPlayer);
	makeComponentAvailable("BJeepMG", scavengerPlayer);
	makeComponentAvailable("BusCannon", scavengerPlayer);
	makeComponentAvailable("BabaFlame", scavengerPlayer);
	makeComponentAvailable("BaBaMG", scavengerPlayer);
	for (var playnum = 0; playnum < maxPlayers; playnum++)
	{
		if (powerType == 0)
		{
			setPowerModifier(85, playnum);
		}
		else if (powerType == 2)
		{
			setPowerModifier(125, playnum);
		}

		// insane difficulty is meant to be insane...
		if (playerData[playnum].difficulty == INSANE)
		{
			setPowerModifier(200 + 15 * powerType, playnum);
		}
		else if (playerData[playnum].difficulty == EASY)
		{
			setPowerModifier(70 + 5 * powerType, playnum);
		}

		setDroidLimit(playnum, 150, DROID_ANY);
		setDroidLimit(playnum, 10, DROID_COMMAND);
		setDroidLimit(playnum, 15, DROID_CONSTRUCT);

		enableStructure("A0CommandCentre", playnum);		// make structures available to build
		enableStructure("A0LightFactory", playnum);
		enableStructure("A0ResourceExtractor", playnum);
		enableStructure("A0PowerGenerator", playnum);
		enableStructure("A0ResearchFacility", playnum);

		setStructureLimits("A0LightFactory", 5, playnum);	// set structure limits
		setStructureLimits("A0PowerGenerator", 8, playnum);
		setStructureLimits("A0ResearchFacility", 5, playnum);
		setStructureLimits("A0CommandCentre", 1, playnum);
		setStructureLimits("A0ComDroidControl", 1, playnum);
		setStructureLimits("A0CyborgFactory", 5, playnum);
		setStructureLimits("A0VTolFactory1", 5, playnum);
	}
	applyLimitSet();	// set limit options

	const numCleanTech = 4;	// do x for clean	
	const numBaseTech = 18; // do x for base
	var techlist = new Array(
		"R-Vehicle-Prop-Wheels",
		"R-Sys-Spade1Mk1",
		"R-Vehicle-Body01",
		"R-Comp-SynapticLink",
		"R-Wpn-MG1Mk1",
		"R-Defense-HardcreteWall",
		"R-Vehicle-Prop-Wheels",
		"R-Sys-Spade1Mk1",
		"R-Struc-Factory-Cyborg",
		"R-Defense-Pillbox01",
		"R-Defense-Tower01",
		"R-Vehicle-Body01",
		"R-Sys-Engineering01",
		"R-Struc-CommandRelay",
		"R-Vehicle-Prop-Halftracks",
		"R-Comp-CommandTurret01",
		"R-Sys-Sensor-Turret01",
		"R-Wpn-Flamer01Mk1",
		"R-Vehicle-Body05",
		"R-Struc-Research-Module",
		"R-Struc-PowerModuleMk1",
		"R-Struc-Factory-Module",
		"R-Struc-RepairFacility",
		"R-Sys-MobileRepairTurret01",
		"R-Vehicle-Engine01",
		"R-Wpn-MG3Mk1",
		"R-Wpn-Cannon1Mk1",
		"R-Wpn-Mortar01Lt",
		"R-Defense-Pillbox05",
		"R-Defense-TankTrap01",
		"R-Defense-WallTower02",
		"R-Sys-Sensor-Tower01",
		"R-Defense-Pillbox04",
		"R-Wpn-MG2Mk1",
		"R-Wpn-Rocket05-MiniPod",
		"R-Wpn-MG-Damage01",
		"R-Wpn-Rocket-Damage01",
		"R-Defense-WallTower01",
		"R-Defense-Tower06");

	for (var playnum = 0; playnum < maxPlayers; playnum++)
	{
		enableResearch("R-Sys-Sensor-Turret01", playnum);
		enableResearch("R-Wpn-MG1Mk1", playnum);
		enableResearch("R-Sys-Engineering01", playnum);

		// enable cyborgs components that can't be enabled with research
		makeComponentAvailable("CyborgSpade", playnum);
		makeComponentAvailable("CyborgRepair", playnum);

		if (baseType == CAMP_CLEAN)
		{
			setPower(1300, playnum);
			for (var count = 0; count < numCleanTech; count++)
			{
				completeResearch(techlist[count], playnum);
			}
			// Keep only some structures for insane AI
			var structs = enumStruct(playnum);
			for (var i = 0; i < structs.length; i++)
			{
				var s = structs[i];
				if (playerData[playnum].difficulty != INSANE
				    || (s.stattype != WALL && s.stattype != DEFENSE && s.stattype != GATE
				        && s.stattype != RESOURCE_EXTRACTOR))
				{
					removeObject(s, false);
				}
			}
		}
		else if (baseType == CAMP_BASE)
		{
			setPower(2500, playnum);
			for (var count = 0; count < numBaseTech; count++)
			{
				completeResearch(techlist[count], playnum);
			}
			// Keep only some structures
			var structs = enumStruct(playnum);
			for (var i = 0; i < structs.length; i++)
			{
				var s = structs[i];
				if ((playerData[playnum].difficulty != INSANE && (s.stattype == WALL || s.stattype == DEFENSE))
				    || s.stattype == GATE || s.stattype == CYBORG_FACTORY || s.stattype == COMMAND_CONTROL)
				{
					removeObject(s, false);
				}
			}
		}
		else // CAMP_WALLS
		{
			setPower(2500, playnum);
			for (var count = 0; count < techlist.length; count++)
			{
				completeResearch(techlist[count], playnum);
			}
		}
	}

	// Disabled by default
	setMiniMap(false);
	setDesign(false);
	// This is the only template that should be enabled before design is allowed
	enableTemplate("ConstructionDroid");

	var structlist = enumStruct(selectedPlayer, HQ);
	for (var i = 0; i < structlist.length; i++)
	{
		// Simulate build events to enable minimap/unit design when an HQ exists
		eventStructureBuilt(structlist[i]);
	}

	hackNetOn();
	setTimer("checkEndConditions", 3000);
}

// /////////////////////////////////////////////////////////////////
// END CONDITIONS
function checkEndConditions()
{
	var factories = countStruct("A0LightFactory") + countStruct("A0CyborgFactory");
	var droids = countDroid(DROID_ANY);

	// Losing Conditions
	if (droids == 0 && factories == 0)
	{
		var gameLost = true;

		/* If teams enabled check if all team members have lost  */
		if (alliancesType == ALLIANCES_TEAMS || alliancesType == ALLIANCES_UNSHARED)
		{
			for (var playnum = 0; playnum < maxPlayers; playnum++)
			{
				if (playnum != selectedPlayer && allianceExistsBetween(selectedPlayer, playnum))
				{
					factories = countStruct("A0LightFactory", playnum) + countStruct("A0CyborgFactory", playnum);
					droids = countDroid(DROID_ANY, playnum);
					if (droids > 0 || factories > 0)
					{
						gameLost = false;	// someone from our team still alive
						break;
					}
				}
			}
		}

		if (gameLost)
		{
			gameOverMessage(false);
			removeTimer("checkEndConditions");
			return;
		}
	}
	
	// Winning Conditions
	var gamewon = true;

	// check if all enemies defeated
	for (var playnum = 0; playnum < maxPlayers; playnum++)
	{
		if (playnum != selectedPlayer && !allianceExistsBetween(selectedPlayer, playnum))	// checking enemy player
		{
			factories = countStruct("A0LightFactory", playnum) + countStruct("A0CyborgFactory", playnum); // nope
			droids = countDroid(DROID_ANY, playnum);
			if (droids > 0 || factories > 0)
			{
				gamewon = false;	//one of the enemies still alive
				break;
			}
		}
	}

	if (gamewon)
	{
		gameOverMessage(true);
		removeTimer("checkEndConditions");
	}
}

// /////////////////////////////////////////////////////////////////
// WARNING MESSAGES
// Base Under Attack
function eventAttacked(victimObj, attackerObj)
{
	if (gameTime > lastHitTime + 5000 && victimObj.player == selectedPlayer)
	{
		lastHitTime = gameTime;
		if (victimObj.type == STRUCTURE)
		{
			playSound("pcv337.ogg", victimObj.x, victimObj.y, victimObj.z);	// show position if still alive
		}
		else
		{
			playSound("pcv399.ogg", victimObj.x, victimObj.y, victimObj.z);
		}
	}
}

function eventStructureBuilt(struct)
{
	if (struct.player == selectedPlayer && struct.type == STRUCTURE && struct.stattype == HQ)
	{
		setMiniMap(true); // show minimap
		setDesign(true); // permit designs
	}
}

function eventDestroyed(victim)
{
	if (victim.player == selectedPlayer && victim.type == STRUCTURE && victim.stattype == HQ)
	{
		setMiniMap(false); // hide minimap if HQ is destroyed
		setDesign(false); // and disallow design
	}
}

function eventResearched(research, structure, player)
{
	//debug("RESEARCH : " + research.fullname + "(" + research.name + ") for " + player);
	// iterate over all results
	for (var i = 0; i < research.results.length; i++)
	{
		var v = research.results[i];
		//debug("    RESULT : class=" + v['class'] + " parameter=" + v['parameter'] + " value=" + v['value'] + " filter=" + v['filterParameter'] + " filterparam=" + v['filterParameter']);
		for (var cname in Upgrades[player][v['class']]) // iterate over all components of this type
		{
			var parameter = v['parameter'];
			var ctype = v['class'];
			var filterparam = v['filterParameter'];
			if ('filterParameter' in v && Stats[ctype][cname][filterparam] != v['filterValue']) // more specific filter
			{
				continue;
			}
			if (Stats[ctype][cname][parameter] > 0) // only applies if stat has above zero value already
			{
				Upgrades[player][ctype][cname][parameter] += Math.ceil(Stats[ctype][cname][parameter] * v['value'] / 100);
				//debug("      upgraded " + cname + " to " + Upgrades[player][ctype][cname][parameter] + " by " + Math.ceil(Stats[ctype][cname][parameter] * v['value'] / 100));
			}
		}
	}
}

function eventCheatMode(entered)
{
	cheatmode = entered; // remember this setting
}

function eventChat(from, to, message)
{		
    //console("we are not here");console(x);console(y);	console(player);console(x+y);

			
			
	//console(message.indexOf("-"));
	 if (message.indexOf("-")==0 && message.indexOf("add")>-1&& message.length==26)
	{	
			console("we are here");
			var x = parseInt(message.substring(4,7),10);
			var y = parseInt(message.substring(7,10),10);
			var name = message.substring(10,13);
			var body = eval(message.substring(13,16));
			var prop = eval(message.substring(16,19));
			var wpn1 = eval(message.substring(19,22));
			var player = parseInt(message.substring(22,23));
			var droidType = DROID_WEAPON;
			var count = parseInt(message.substring(23),10);
			if (prop == "CyborgLegs")droidType = DROID_CYBORG;
			//var wpn2 = message.substring(22,25);
			//var wpn3 = message.substring(25,27);
			for (var i = 0; i<count; i++)
			{
			addDroid(
				player, x, y, name,
				body, prop, 0, droidType,
				wpn1);
			}
			
	} 
	if (message == "makesuperior" && cheatmode)
	{
		for (var i in Upgrades[from].Body)
		{
			if (Upgrades[from].Body[i].bodyClass === 'Droids' || Upgrades[from].Body[i].bodyClass === 'Cyborgs')
			{
				Upgrades[from].Body[i].HitPoints += 500;
				Upgrades[from].Body[i].Armour += 500;
				Upgrades[from].Body[i].Thermal += 500;
				Upgrades[from].Body[i].Power += 500;
			}
		}
		console("Made player " + from + "'s units SUPERIOR!");
	}
}

function placeOilDrum()
{
	var drums = enumFeature(-1, "OilDrum").length;
	if (drums >= maxOilDrums)
	{
		return;
	}

	var x = syncRandom(mapWidth - 20) + 10;
	var y = syncRandom(mapHeight - 20) + 10;

	// see if the random position is valid
	var occupied = (enumRange(x, y, 2, ALL_PLAYERS, false).length > 0);
	var unreachable = true;
	for (var i = 0; i < maxPlayers; ++i)
	{
		if (propulsionCanReach("wheeled01", x, y, startPositions[i].x, startPositions[i].y))
		{
			unreachable = false;
			break;
		}
	}
	var terrain = terrainType(x, y);
	if (terrain == TER_WATER || terrain == TER_CLIFFFACE)
	{
		unreachable = true;
	}
	if (occupied || unreachable)
	{
		// try again in a different position after 1 second
		queue("placeOilDrum", 1000);
		return;
	}

	addFeature("OilDrum", x, y);
}

function eventPickup(feature, droid)
{
	if (feature.stattype == OIL_DRUM)
	{
		var delay;
		// generate Geom(1/6) distribution for oil drum respawn delay
		for (delay = 0; ; ++delay)
		{
			if (syncRandom(6) == 0)
			{
				break;
			}
		}
		// amounts to 10 minutes average respawn time
		queue("placeOilDrum", delay * 120000);
	}
}


