var stats = {
	weapons: [
		[
			{ stat: "MG1Mk1", weight: WEIGHT.ULTRALIGHT, value: 5 },
			{ stat: "MG2Mk1", weight: WEIGHT.LIGHT, value: 10 },
			{ stat: "MG3Mk1", weight: WEIGHT.MEDIUM, value: 15 },
			{ stat: "MG4ROTARYMk1", weight: WEIGHT.MEDIUM, value: 25 },
			{ stat: "MG5TWINROTARY", weight: WEIGHT.MEDIUM, value: 35 },
			{ stat: "Laser3BEAMMk1", weight: WEIGHT.ULTRALIGHT, value: 50 },
			{ stat: "Laser2PULSEMk1", weight: WEIGHT.HEAVY, value: 75 },
			{ stat: "HeavyLaser", weight: WEIGHT.ULTRAHEAVY, value: 100 },
		],

		[
			{ stat: "Cannon1Mk1", weight: WEIGHT.LIGHT, value: 15 },
			{ stat: "Cannon2A-TMk1", weight: WEIGHT.HEAVY, value: 20 },
			{ stat: "Cannon4AUTOMk1", weight: WEIGHT.HEAVY, value: 30 }, 
			{ stat: "Cannon5VulcanMk1", weight: WEIGHT.HEAVY, value: 40 },
			{ stat: "Cannon6TwinAslt", weight: WEIGHT.ULTRAHEAVY, value: 50 },
			{ stat: "Cannon375mmMk1", weight: WEIGHT.ULTRAHEAVY, value: 60 },
			{ stat: "RailGun1Mk1", weight: WEIGHT.LIGHT, value: 75 },
			{ stat: "RailGun2Mk1", weight: WEIGHT.HEAVY, value: 125 },
			{ stat: "RailGun3Mk1", weight: WEIGHT.ULTRAHEAVY, value: 150 }, 
		],

		[
			{ stat: "Rocket-Pod", weight: WEIGHT.LIGHT, value: 15 },
			{ stat: "Rocket-LtA-T", weight: WEIGHT.LIGHT, value: 20 },
			{ stat: "Rocket-MRL", weight: WEIGHT.LIGHT, value: 25 },
			{ stat: "Rocket-IDF", weight: WEIGHT.ULTRAHEAVY, value: 35 },
			{ stat: "Rocket-HvyA-T", weight: WEIGHT.LIGHT, value: 45 },
			{ stat: "Missile-A-T", weight: WEIGHT.LIGHT, value: 65 },
			{ stat: "Missile-MdArt", weight: WEIGHT.HEAVY, value: 90 },
			{ stat: "Missile-HvyArt", weight: WEIGHT.ULTRAHEAVY, value: 125 },
		],

		[
			{ stat: "Flame1Mk1", weight: WEIGHT.LIGHT, value: 10 },
			{ stat: "Flame2", weight: WEIGHT.HEAVY, value: 25 },
			{ stat: "PlasmiteFlamer", weight: WEIGHT.HEAVY, value: 40 },
			{ stat: "Laser3BEAMMk1", weight: WEIGHT.ULTRALIGHT, value: 50 },
			{ stat: "Laser2PULSEMk1", weight: WEIGHT.HEAVY, value: 75 },
			{ stat: "HeavyLaser", weight: WEIGHT.ULTRAHEAVY, value: 100 },
		],

		[
			{ stat: "Mortar1Mk1", weight: WEIGHT.HEAVY, value: 25 },
			{ stat: "Mortar2Mk1", weight: WEIGHT.HEAVY, value: 30 },
			{ stat: "Mortar3ROTARYMk1", weight: WEIGHT.HEAVY, value: 35 },
			{ stat: "Howitzer105Mk1", weight: WEIGHT.ULTRAHEAVY, value: 45 },
			{ stat: "Mortar-Incenediary", weight: WEIGHT.HEAVY, value: 50 },
			{ stat: "Howitzer03-Rot", weight: WEIGHT.ULTRAHEAVY, value: 60 },
			{ stat: "Howitzer150Mk1", weight: WEIGHT.ULTRAHEAVY, value: 75 },
			{ stat: "Howitzer-Incenediary", weight: WEIGHT.ULTRAHEAVY, value: 50 },
		],
		/*
		will work on ground units without reload but will make them a lot stronger, be sure to comment bombs if u want to use it they work too but will look ugly
		 [
			{ stat: "MG1-VTOL", weight: WEIGHT.LIGHT, value: 25 },
			{ stat: "MG2-VTOL", weight: WEIGHT.LIGHT, value: 30 },
			{ stat: "MG3-VTOL", weight: WEIGHT.LIGHT, value: 35 },
			{ stat: "MG4ROTARY-VTOL", weight: WEIGHT.LIGHT, value: 45 },
			{ stat: "Laser3BEAM-VTOL", weight: WEIGHT.LIGHT, value: 50 },
			{ stat: "Laser2PULSE-VTOL", weight: WEIGHT.LIGHT, value: 60 },
			{ stat: "HeavyLaser-VTOL", weight: WEIGHT.MEDIUM, value: 75 },
		],
		
		[
			{ stat: "Rocket-VTOL-Pod", weight: WEIGHT.LIGHT, value: 25 },
			{ stat: "Rocket-VTOL-LtA-T", weight: WEIGHT.LIGHT, value: 30 },
			{ stat: "Rocket-VTOL-HvyA-T", weight: WEIGHT.LIGHT, value: 35 },
			{ stat: "Rocket-VTOL-BB", weight: WEIGHT.LIGHT, value: 45 },
			{ stat: "Missile-VTOL-AT", weight: WEIGHT.LIGHT, value: 50 },
		],
		
		[
			{ stat: "Cannon1-VTOL", weight: WEIGHT.LIGHT, value: 25 },
			{ stat: "Cannon4AUTO-VTOL", weight: WEIGHT.LIGHT, value: 30 },
			{ stat: "Cannon5Vulcan-VTOL", weight: WEIGHT.MEDIUM, value: 35 },
			{ stat: "RailGun1-VTOL", weight: WEIGHT.LIGHT, value: 45 },
			{ stat: "RailGun2-VTOL", weight: WEIGHT.MEDIUM, value: 50 },
		],
		
		[
			{ stat: "Bomb1-VTOL-LtHE", weight: WEIGHT.LIGHT, value: 25 },
			{ stat: "Bomb2-VTOL-HvHE", weight: WEIGHT.LIGHT, value: 30 },
			{ stat: "Bomb3-VTOL-LtINC", weight: WEIGHT.LIGHT, value: 35 },
			{ stat: "Bomb4-VTOL-HvyINC", weight: WEIGHT.LIGHT, value: 45 },
			{ stat: "Bomb5-VTOL-Plasmite", weight: WEIGHT.LIGHT, value: 60 },
		], */
	],
	VTOLweapons: [
		[
			{ stat: "MG1-VTOL", weight: WEIGHT.ULTRALIGHT, value: 5 },
			{ stat: "MG2-VTOL", weight: WEIGHT.LIGHT, value: 10 },
			{ stat: "MG3-VTOL", weight: WEIGHT.LIGHT, value: 15 },
			{ stat: "MG4ROTARY-VTOL", weight: WEIGHT.LIGHT, value: 25 },
			{ stat: "Laser3BEAM-VTOL", weight: WEIGHT.LIGHT, value: 35 },
			{ stat: "Laser2PULSE-VTOL", weight: WEIGHT.LIGHT, value: 50 },
			{ stat: "HeavyLaser-VTOL", weight: WEIGHT.MEDIUM, value: 75 },
		],
		
		[
			{ stat: "Rocket-VTOL-Pod", weight: WEIGHT.LIGHT, value: 15 },
			{ stat: "Rocket-VTOL-LtA-T", weight: WEIGHT.LIGHT, value: 20 },
			{ stat: "Rocket-VTOL-HvyA-T", weight: WEIGHT.LIGHT, value: 35 },
			{ stat: "Rocket-VTOL-BB", weight: WEIGHT.LIGHT, value: 45 },
			{ stat: "Missile-VTOL-AT", weight: WEIGHT.LIGHT, value: 65 },
		],
		
		[
			{ stat: "Cannon1-VTOL", weight: WEIGHT.LIGHT, value: 15 },
			{ stat: "Cannon4AUTO-VTOL", weight: WEIGHT.LIGHT, value: 30 },
			{ stat: "Cannon5Vulcan-VTOL", weight: WEIGHT.MEDIUM, value: 40 },
			{ stat: "RailGun1-VTOL", weight: WEIGHT.LIGHT, value: 75 },
			{ stat: "RailGun2-VTOL", weight: WEIGHT.MEDIUM, value: 125 },
		],
		
		[
			{ stat: "Bomb1-VTOL-LtHE", weight: WEIGHT.LIGHT, value: 25 },
			{ stat: "Bomb3-VTOL-LtINC", weight: WEIGHT.LIGHT, value: 35 },
			{ stat: "Bomb2-VTOL-HvHE", weight: WEIGHT.MEDIUM, value: 60 },
			{ stat: "Bomb4-VTOL-HvyINC", weight: WEIGHT.MEDIUM, value: 65 },
			{ stat: "Bomb5-VTOL-Plasmite", weight: WEIGHT.HEAVY, value: 80 },
		],
	],
	bodies: [
		[
			{ stat: "Body4ABT", weight: WEIGHT.LIGHT, value: 5 },
			{ stat: "Body8MBT", weight: WEIGHT.MEDIUM, value: 25 },
			{ stat: "Body12SUP", weight: WEIGHT.HEAVY, value: 45 },
		],

		[
			{ stat: "Body2SUP", weight: WEIGHT.LIGHT, value: 10 },
			{ stat: "Body6SUPP", weight: WEIGHT.MEDIUM, value: 30 },
			{ stat: "Body9REC", weight: WEIGHT.HEAVY, value: 60 },
		],

		[
			{ stat: "Body3MBT", weight: WEIGHT.LIGHT, value: 20 },
			{ stat: "Body7ABT", weight: WEIGHT.MEDIUM, value: 45 },
			{ stat: "Body10MBT", weight: WEIGHT.HEAVY, value: 80 },
		],
	],
	propulsions: [
		[
			{ stat: "wheeled01", value: 5 },
			{ stat: "HalfTrack", value: 15 },
			{ stat: "tracked01", value: 25 },
		],

		[
			{ stat: "hover01", value: 30 },
		],
		[
			{ stat: "V-Tol", value: 25 },
		],
	],
	cyborgs32: [
		{ body: "CyborgLightBody", propulsion: "CyborgLegs", weapons: [ "CyborgChaingun", ], value: 30 }, // mg cyborg
		{ body: "CyborgLightBody", propulsion: "CyborgLegs", weapons: [ "CyborgFlamer01", ], value: 35 }, // flamer cyborg
		{ body: "CyborgLightBody", propulsion: "CyborgLegs", weapons: [ "CyborgCannon", ], value: 45 }, // lc borg
		{ body: "CyborgLightBody", propulsion: "CyborgLegs", weapons: [ "Cyb-Wpn-Grenade", ], value: 55 }, // mortar borg
		{ body: "CyborgLightBody", propulsion: "CyborgLegs", weapons: [ "CyborgRocket", ], value: 60 }, // lancer borg
		{ body: "CyborgLightBody", propulsion: "CyborgLegs", weapons: [ "Cyb-Wpn-Thermite", ], value: 65 }, // thermite cyborg
		{ body: "CyborgLightBody", propulsion: "CyborgLegs", weapons: [ "CyborgRotMG", ], value: 75 }, // ag cyborg
		{ body: "CyborgHeavyBody", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-Mcannon", ], value: 90 }, // mc super
		{ body: "CyborgHeavyBody", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-HPV", ], value: 95 }, // hpv super
		{ body: "CyborgHeavyBody", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-TK", ], value: 100 }, // tk super
		{ body: "CyborgHeavyBody", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-Acannon", ], value: 110 }, // ac super
		{ body: "CyborgLightBody", propulsion: "CyborgLegs", weapons: [ "Cyb-Wpn-Laser", ], value: 120 }, // flash borg
		{ body: "CyborgLightBody", propulsion: "CyborgLegs", weapons: [ "Cyb-Wpn-Atmiss", ], value: 140 }, // scourge borg
		{ body: "CyborgLightBody", propulsion: "CyborgLegs", weapons: [ "Cyb-Wpn-Rail1", ], value: 160 }, // needle borg
		{ body: "CyborgHeavyBody", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-PulseLsr", ], value: 200 }, // pulse super
		{ body: "CyborgHeavyBody", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-A-T", ], value: 250 }, // scourge super
		{ body: "CyborgHeavyBody", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-RailGunner", ], value: 300 }, // rail super
	],
	cyborgs31: [
		{ body: "CyborgChain1Ground", propulsion: "CyborgLegs", weapons: [ "CyborgChaingun", ], value: 30 }, // mg cyborg
		{ body: "CyborgFlamerGrd", propulsion: "CyborgLegs", weapons: [ "CyborgFlamer01", ], value: 35 }, // flamer cyborg
		{ body: "CyborgCannonGrd", propulsion: "CyborgLegs", weapons: [ "CyborgCannon", ], value: 45 }, // lc borg
		{ body: "Cyb-Bod-Grenade", propulsion: "CyborgLegs", weapons: [ "Cyb-Wpn-Grenade", ], value: 55 }, // mortar borg
		{ body: "CyborgRkt1Ground", propulsion: "CyborgLegs", weapons: [ "CyborgRocket", ], value: 60 }, // lancer borg
		{ body: "Cyb-Bod-Thermite", propulsion: "CyborgLegs", weapons: [ "Cyb-Wpn-Thermite", ], value: 65 }, // thermite cyborg
		{ body: "CybRotMgGrd", propulsion: "CyborgLegs", weapons: [ "CyborgRotMG", ], value: 75 }, // ag cyborg
		{ body: "Cyb-Hvybod-Mcannon", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-Mcannon", ], value: 90 }, // mc super
		{ body: "Cyb-Hvybod-HPV", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-HPV", ], value: 95 }, // hpv super
		{ body: "Cyb-Hvybod-TK", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-TK", ], value: 100 }, // tk super
		{ body: "Cyb-Hvybod-Acannon", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-Acannon", ], value: 110 }, // ac super
		{ body: "Cyb-Bod-Las1", propulsion: "CyborgLegs", weapons: [ "Cyb-Wpn-Laser", ], value: 120 }, // flash borg
		{ body: "Cyb-Bod-Atmiss", propulsion: "CyborgLegs", weapons: [ "Cyb-Wpn-Atmiss", ], value: 140 }, // scourge borg
		{ body: "Cyb-Bod-Rail1", propulsion: "CyborgLegs", weapons: [ "Cyb-Wpn-Rail1", ], value: 160 }, // needle borg
		{ body: "Cyb-Hvybod-PulseLsr", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-PulseLsr", ], value: 200 }, // pulse super
		{ body: "Cyb-Hvybod-A-T", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-A-T", ], value: 250 }, // scourge super
		{ body: "Cyb-Hvybod-RailGunner", propulsion: "CyborgLegs", weapons: [ "Cyb-Hvywpn-RailGunner", ], value: 300 }, // rail super
	],
};